Processing math: 100%
(Analysis by Suhas Nagar and Andi Qu)

Let ci be the i-th cowmpetency value in the sequence. We can think of each ci as a free variable (i.e., we can adjust its value as we see fit) and each pair (ai,hi) as a constraint on the free variables. Specifically, each constraint dictates that:

maxai<k<hi(ck)maxkai(ck)<chi

Subtask 1: O(NQCN)

For this subtask, it works to iterate over all CN sequences and check each one against the list of constraints.

Subtasks 2 and 3: O(NC2)

Like many other problems involving counting something modulo a large number, this problem's full solution involves dynamic programming (DP). Let dp[i][j] be the number of ways to satisfy the constraints when you only consider the first i cows and have maxki(ck)=j.

There are two different contributions to dp[i][j]:

  1. Case 1: cimaxk<i(ck)cij. This case is only possible if no constraint has hk=i. If so, there are j options for ci in this case, so this case contributes jdp[i1][j].
  2. Case 2: ci>maxk<i(ck)ci=j. This case is only possible if no constraint has aki<hk. If so, there is 1 option for ci in this case, so this case contributes j1k=1dp[i1][k].

Computing these two contributions naively takes O(C) time for each dp[i][j], so this approach runs in O(NC2) time overall. Slower solutions that run in O(NC(C+Q)) time may also pass both subtasks, but more likely pass only Subtask 2.

Python code:

MOD = int(1e9 + 7)
n, q, c = map(int, input().split())

i_start = [False for i in range(n + 1)]
i_end = [False for i in range(n + 1)]
for i in range(q):
    a, h = map(int, input().split())
    i_start[a] = True
    i_end[h] = True

dp = [[0 for j in range(c + 1)] for i in range(n + 1)]
dp[0][0] = 1
restrict = False
for i in range(1, n + 1):
    if i_end[i]:
        restrict = False
    for j in range(1, c + 1):
        if not i_end[i]:
            dp[i][j] = j * dp[i - 1][j] % MOD
        if not restrict:
            for k in range(j):
                dp[i][j] += dp[i - 1][k]
                if dp[i][j] >= MOD:
                    dp[i][j] -= MOD
    if i_start[i]:
        restrict = True

print(sum(dp[n]) % MOD)

Subtask 4: O(NC)

We can speed up the above solution by using a prefix sum array to compute Case 2. This optimization improves the time complexity by a factor of C.

Python code:

MOD = int(1e9 + 7)
n, q, c = map(int, input().split())

i_start = [False for i in range(n + 1)]
i_end = [False for i in range(n + 1)]
for i in range(q):
    a, h = map(int, input().split())
    i_start[a] = True
    i_end[h] = True

dp = [[0 for j in range(c + 1)] for i in range(n + 1)]
pref = [[0 for j in range(c + 1)] for i in range(n + 1)]
dp[0][0] = 1
pref[0] = [1 for j in range(c + 1)]
restrict = False
for i in range(1, n + 1):
    if i_end[i]:
        restrict = False
    for j in range(1, c + 1):
        if not i_end[i]:
            dp[i][j] = j * dp[i - 1][j] % MOD
        if not restrict:
            dp[i][j] += pref[i - 1][j - 1]
            if dp[i][j] >= MOD:
                dp[i][j] -= MOD
    pref[i][0] = dp[i][0]
    for j in range(1, c + 1):
        pref[i][j] = pref[i][j - 1] + dp[i][j]
        if pref[i][j] >= MOD:
            pref[i][j] -= MOD
    if i_start[i]:
        restrict = True

print(pref[n][c])

Full Credit: O(QClogN)

Consider each constraint (ai,hi) as a range [ai,hi1] on a number line. Because the problem guarantees that the number of valid sequences is not 0, two of these ranges (say i and j) can intersect only if hi=hj. For any two such intersecting ranges, only the one with the smaller a value affects the answer.

From this observation, the list of constraints splits the sequence into Q disjoint ranges. Because each free variable in a given range is essentially identical, we can compute the answer more efficiently by iterating over constraints (after sorting them) instead of cows.

Now, let dp[i][j] be the number of ways to satisfy up to the first i constraints and have chi=j. Additionally, let wi be the number of free variables in constraint i's range, and ui be the number of free variables between constraint i's range and constraint i1's range.

There are three different contributions to dp[i][j]:

  1. Case 1: Any sequence counted in dp[i][j1] can also count toward dp[i][j] by changing chi from j1 to j.
  2. Case 2: Any sequence counted in dp[i1][j1] can also count toward dp[i][j] if all wi+ui free variables under consideration are assigned values between 1 to j1.
  3. Case 3: Any sequence counted in dp[i1][k] where k<j1 can also count toward dp[i][j] if at least one of the wi free variables in constraint i's range is equal to j1 and the rest are no more than j1. There are ((j1)wi(j2)wi)jui ways to do this assignment.

Putting it all together, our DP recurrence is:

dp[i][j]=dp[i][j1]+dp[i1][j1](j1)wi+ui+j2k=0dp[i1][k]((j1)wi(j2)wi)jui

We can compute each term in O(logN) time using a running sum and binary exponentiation.

Python code:

MOD = int(1e9 + 7)


def expo(base, pow):
    if pow == 0:
        return 1
    x = expo(base * base % MOD, pow // 2)
    return base * x % MOD if pow % 2 == 1 else x


n, q, c = map(int, input().split())

pairs_dict = {0: 0}
for i in range(q):
    a, h = map(int, input().split())
    pairs_dict[h] = min(a, pairs_dict.get(h, h))
pairs = sorted((a, h) for h, a in pairs_dict.items())
q = len(pairs_dict) - 1

dp = [[0 for j in range(c + 1)] for i in range(q + 1)]
dp[0][0] = 1
for i in range(1, q + 1):
    gap1 = pairs[i][0] - pairs[i - 1][1]
    gap2 = pairs[i][1] - pairs[i][0] - 1
    pref_sum = 0
    for j in range(1, c + 1):
        dp[i][j] = (dp[i][j - 1] + dp[i - 1][j - 1] * expo(j - 1, gap1 + gap2) +
                    pref_sum * (expo(j - 1, gap1) - expo(j - 2, gap1)) * expo(j - 1, gap2)) % MOD
        pref_sum = (pref_sum + dp[i - 1][j - 1]) % MOD

print(sum(dp[q]) * expo(c, n - pairs[q][1]) % MOD)